<template>
  <div>
    <el-form :model="ruleForm" :rules="rules" ref="form" @submit.native.prevent>
      <el-form-item prop="account">
        <el-input v-model="ruleForm.account" placeholder="邮箱/手机号" @keyup.enter.native="handleSubmit">
          <i slot="prefix" class="el-input__icon el-icon-user"></i>
        </el-input>
      </el-form-item>
      <el-form-item prop="password">
        <el-input
          type="password"
          v-model="ruleForm.password"
          placeholder="请输入登录密码"
          @keyup.enter.native="handleSubmit"
        >
          <i slot="prefix" class="el-input__icon el-icon-lock"></i>
        </el-input>
      </el-form-item>
      <el-checkbox v-model="ruleForm.RememberMe" style="margin-bottom: 10px">记住我</el-checkbox>
      <el-button type="primary" class="submit-button" :loading="loading" @click="handleSubmit">登录</el-button>
    </el-form>
    <div class="login-footer">
      <router-link to="code">验证码登录</router-link>
      <router-link to="../password">忘记密码</router-link>
    </div>
  </div>
</template>

<script>
import * as api from '@/api/account'

export default {
  name: 'LoginAccount',
  data() {
    return {
      ruleForm: { type: 1, account: '', password: '', RememberMe: false, service: 'https://h5.ezijing.com' },
      rules: {
        account: [{ required: true, message: '请输入账号', trigger: 'change' }],
        password: [{ required: true, message: '请输入密码', trigger: 'change' }]
      },
      loading: false
    }
  },
  computed: {
    // 重定向地址
    nextUrl() {
      const nextUrl = window.sessionStorage.getItem('next_url')
      return nextUrl ? decodeURIComponent(nextUrl) : ''
    }
  },
  methods: {
    // 提交
    handleSubmit() {
      this.$refs.form.validate().then(this.handleRequest)
    },
    // 接口请求
    handleRequest() {
      this.loading = true
      api.login(this.ruleForm).then(response => {
        response.code === 0 ? this.handleSuccess(response) : this.$message.error(response.msg)
        this.loading = false
      })
    },
    // 登录成功
    handleSuccess(response) {
      this.$message({ type: 'success', message: '登录成功' })
      if (this.nextUrl) {
        window.location.href = this.nextUrl
      } else {
        this.$emit('success', response)
      }
    }
  }
}
</script>
